﻿using System;
using System.Collections.Generic;
using System.IO;
using Opalis.QuickIntegrationKit;
using System.Text;

namespace Utilities.Filesystem
{
    [OpalisObject("Read File to String",ShowFilters = false)]
    public class ReadFileToString : IOpalisObject
    {
        public void Design(IOpalisDesigner designer)
        {
            designer.AddInput("FileName").WithFileBrowser();
            designer.AddInput("FilePath").WithFolderBrowser();
            designer.AddOutput("File Contents").AsString();
        }

        public void Execute(IOpalisRequest request, IOpalisResponse response)
        {
            String fileName = request.Inputs["FileName"].AsString();
            String DirectoryLocation = request.Inputs["FilePath"].AsString();
            
            String fileFullPath = DirectoryLocation + "\\" + fileName;

            StreamReader SR = File.OpenText(fileFullPath);

            String ReturnString = SR.ReadToEnd();

            SR.Close();

            response.Publish("File Contents", ReturnString);
        }
    }
}
