﻿using System;
using System.Collections.Generic;
using Microsoft.Win32;
using Opalis.QuickIntegrationKit;
using System.Text;

namespace Utilities.Registry
{
    [OpalisObject("Set Registry Key String Value")]
    public class ModifyRegistryKeyValueString : IOpalisObject
    {
        public void Design(IOpalisDesigner designer)
        {
            designer.AddInput("Key Path:  HKLM:\\");
            designer.AddInput("Value Name");
            designer.AddInput("New Value");
            designer.AddInput("Server Name").WithComputerBrowser();
            designer.AddOutput("Results").AsString();
        }

        public void Execute(IOpalisRequest request, IOpalisResponse response)
        {
            String results = "";
            String KeyPath = request.Inputs["Key Path:  HKLM:\\"].AsString();
            String ServerName = request.Inputs["Server Name"].AsString();
            String ValueName = request.Inputs["Value Name"].AsString();
            String NewValue = request.Inputs["New Value"].AsString();

            try
            {
                RegistryKey rk = RegistryKey.OpenRemoteBaseKey(RegistryHive.LocalMachine, ServerName);
                RegistryKey sk = rk.CreateSubKey(KeyPath);
                sk.SetValue(ValueName, NewValue);
                results = sk.GetValue(ValueName).ToString();
            }
            catch (Exception ex)
            {
                response.LogErrorMessage(ex.Message.ToString());
                throw ex;
            }

            response.Publish("Results", results);
        }
    }
}
