﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using Opalis.QuickIntegrationKit;

namespace Utilities.System
{
    [OpalisObject("Sleep")]
    public class Sleep : IOpalisObject
    {
        public void Design(IOpalisDesigner designer)
        {
            designer.AddInput("Sleep Seconds");
        }

        public void Execute(IOpalisRequest request, IOpalisResponse response)
        {
            int sleepSeconds = request.Inputs["Sleep Seconds"].AsInt32();

            Thread.Sleep(TimeSpan.FromSeconds(sleepSeconds));

            response.Publish("Sleep Minutes", sleepSeconds);
        }
    }
}
