﻿using System;
using System.Collections.Generic;
using Opalis.QuickIntegrationKit;
using System.Text;

namespace Utilities.Text
{
    [OpalisObject("Select Individual Line",Description="0 indexed",ShowFilters=false)]
    public class ParseLine : IOpalisObject
    {
        public void Design(IOpalisDesigner designer)
        {
            designer.AddInput("Input String");
            designer.AddInput("Line");
            designer.AddOutput("Output Line").AsString();
        }

        public void Execute(IOpalisRequest request, IOpalisResponse response)
        {
            String inputString = request.Inputs["Input String"].AsString();
            int line = request.Inputs["Line"].AsInt32();
            String[] outputStringArray = inputString.Split('\n');
            response.Publish("Output Line", outputStringArray[line]);
        }
    }
}