﻿using System;
using System.Collections.Generic;
using Opalis.QuickIntegrationKit;
using System.Text;

namespace Utilities.Text
{
    [OpalisObject]
    public class SplitString
    {
        private string text;
        private string separators;
        private StringSplitOptions options;
        private int index;

        [OpalisInput]
        public string Text
        {
            set { text = value; }
        }

        [OpalisInput]
        public string Separators
        {
            set { separators = value; }
        }

        [OpalisInput]
        public int Index
        {
            set { index = value; }
        }

        [OpalisInput("Remove Empty Entries", Default = true)]
        public bool RemoveEmpty
        {
            set { options = value ? StringSplitOptions.RemoveEmptyEntries : StringSplitOptions.None; }
        }

        [OpalisOutput, OpalisFilter]
        public string Item
        {
            get 
            {
                string[] retValue = text.Split(separators.ToCharArray(), options);
                return retValue[index];
            }
        }
    }
}
